# Overview

[SpagoBI](http://spagobi.org/) is the 100% open source, complete and flexible Business Intelligence suite. Developed and supported by the SpagoBI Labs of [Engineering Group](http://www.eng.it/), it provides full analytical capabilities, ranging from traditional reporting and charting features to innovative solutions for emerging domains, such as self-service cockpits, location intelligence, what-if analytics, social listening and real-time BI.

# Usage

##General

The SpagoBI charm requires a database (MySQL) and an Application server 
(Apache Tomcat) to function properly.  The mysql and tomcat charms already 
have the installation and configuration done for you. 

Use the following steps to set up SpagoBI:

        juju deploy mysql
        juju deploy tomcat
        juju deploy spagobi
        juju add-relation spagobi tomcat *(This step installs SpagoBI in Tomcat)*
        juju add-relation spagobi:metadataddb mysql  *(This step creates the database for SpagoBI)* 
        juju expose tomcat

SpagoBI requires a database connection and will remain undeployed until the 
relation to MySQL exists.  If the relation is removed or destroyed Tomcat 
will be shutdown, SpagoBI will be undeployed and the charm will wait for a new 
database connection. 

It is important to wait for SpagoBI and Tomcat to finish starting before 
accessing the web site.  Use the `juju status` command to see the status of 
the deployments and to copy the IP address and http port of Tomcat. 

##Datasources 
Datasource on SpagoBI represents one database. Datasources could be added from SpagoBI application and also from juju using juju actions.
To add datasource using juju actions firts thing is to create relation between spagobi and database server.
 
For mysql datasource:

        juju add-relation spagobi:mysqlds mysql

For postgresql datasource:
 
        juju add-relation spagobi:postgresqlds postgresql

For mongodb datasource:

        juju add-relation spagobi:mongodbds mysql

For hive datasource:

        juju add-relation spagobi:hiveds hive


For cassandra datasource:
 
        juju add-relation spagobi:cassandrads cassandra

For hbase datasource:

        juju add-relation spagobi:hbaseds hbase

 Then create datasource for spagobi using juju action command:
     
        juju action do spagobi/0 add-datasource unitname="<unit/number>" database="<database_name>" username="<username>" password="<password>"


parameters of the action are: unitname - to specify the unit that contains database, database - database name username and password- to access database 


# Contact Information
More information about SpagoBI can be found at:
    - [SpagoBI website](http://spagobi.org/)
    - [SpagoBI WIKI](http://wiki.spagobi.org/xwiki/bin/view/Main/)


